#ifndef TREE_HPP
#define TREE_HPP

#include "node.hpp"

#include <vector>

class Tree {
public:
    // Constructor
    Tree() = delete;
    Tree(double* masses, double* particles, double* forces_, unsigned nParticles, double size, double* center);
    // Destructor
    ~Tree();
    // Calculate force on a particle
    void calculateForce(unsigned particle);
    // Update tree
    void update();

private:
    Node* root_;

    double* masses_;
    double* particles_;
    double* forces_;
    unsigned nParticles_;

    double size_;
    double center_[3];

    // allParticles contains all indices, so [0, 1, 2, ..., nParticles_-1]. It should never be changed. 
    std::vector<unsigned> allParticles_;
};

#endif /* TREE_HPP */